VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRNG"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'
'    Copyright (C) 2008  Colin Caprani - www.colincaprani.com
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
'local variable(s) to hold property value(s)
Private m_rand As Double 'local copy
'local variable(s) to hold property value(s)
Private m_seed As Double 'local copy
Private idum As Double
Dim firstCall As Boolean

Public Property Let seed(ByVal vData As Integer)
    m_seed = vData
    firstCall = True
End Property

Public Property Get rand() As Double
    If m_seed = 0 Then m_seed = 1
    If firstCall Then
        rand = ran7(m_seed)
        firstCall = False
    Else
        rand = ran7(idum)
    End If
End Property

Private Function ran1(idum) As Double
Const ia As Integer = 16807
Const im As Double = 2147483647
Const iq As Double = 127773
Const ir As Double = 2836
Const eps As Double = 0.00000012
Const ntab As Integer = 32
Dim am As Double, rnmx As Double, ndiv As Double

Static temp As Double
If firstCall Then temp = idum
idum = temp

am = 1 / im
ndiv = Round(1 + (im - 1) / ntab, 0)
rnmx = 1 - eps

Dim j As Integer, k As Integer, iv(ntab) As Double, iy As Double

If idum <= 0 Or iy = 0 Then
    idum = max(-idum, 1)

    For j = ntab + 8 To 1 Step -1
        
        k = CInt(idum / iq - 0.5)
        idum = ia * (idum Mod iq) - ir * k
        If idum < 0 Then idum = idum + im
        
        If j <= ntab Then iv(j) = idum
        'If j <= ntab Then iv(j) = ran7(idum) * im
    Next j
    iy = iv(1)
End If

k = CInt(idum / iq - 0.5)
idum = ia * (idum Mod iq) - ir * k
If idum < 0 Then idum = idum + im

For j = 1 To 32
    Debug.Print iv(j)
Next j
Debug.Print "***********************************"
j = 1 + iy / ndiv

'*******STEP 2 EXTRACT NO FROM TABLE****************
iy = iv(j)
'*******STEP 3 REPLACE WITH CURRENT I***************
iv(j) = idum
'iv(j) = ran7(idum) * im

temp = iy

ran1 = min(am * iy, rnmx)
End Function

Private Function ran8(idum) As Double
Const ntab As Integer = 32
Dim j As Integer, k As Integer, iv(ntab) As Double, iy As Double

Static temp As Double
If firstCall Then temp = idum
idum = temp

For j = ntab + CInt(8 * Rnd) To 1 Step -1
    If j <= ntab Then iv(j) = ran7(idum)
Next j

'For j = 1 To 32
'    Debug.Print iv(j)
'Next j

j = CInt(32 * Rnd + 0.5)

iy = iv(j)

iv(j) = ran7(idum)

temp = iy

ran8 = iy

End Function

Private Function ran6(idum) As Double
Dim k As Integer, a As Integer, c As Integer, m As Double
Static temp As Double

If firstCall Then temp = idum
idum = temp
m = 2147483647: a = 16807: c = 1

k = CInt((a * idum + c) / m - 0.5)
idum = a * idum + c - m * k
temp = idum
ran6 = idum / m


End Function

Private Function ran7(idum) As Double
Const ia As Integer = 16807
Const im As Double = 2147483647
Const iq As Double = 127773
Const ir As Double = 2836
Const eps As Double = 0.00000012
Const ntab As Integer = 32
Dim am As Double
Static temp As Double

If firstCall Then temp = idum
idum = temp

am = 1 / im

Dim k As Integer

k = CInt(idum / iq - 0.5)
idum = ia * (idum Mod iq) - ir * k
If idum < 0 Then idum = idum + im

temp = idum
ran7 = idum * am

End Function

Private Function max(a, b) As Variant

If a > b Then
    max = a
Else
    max = b
End If

End Function

Private Function min(a, b) As Variant

If a < b Then
    min = a
Else
    min = b
End If

End Function

Private Function modulus(a, b) As Integer
Dim remainder As Integer, result As Integer

result = CInt(a / b)
modulus = a - result * b

End Function


